<?php

const VIDLY_USER_ID = REMOVED;
const VIDLY_USER_KEY = 'REMOVED';


class VidlyAPI {

    private $userId;
    private $userKey;
    private $vidlyUrl;
    private $ch;

    /**
     * @param $vidlyUrl
     * @param $userId
     * @param $userKey
     */
    public function __construct($vidlyUrl, $userId, $userKey)
    {
        $this->vidlyUrl = $vidlyUrl;
        $this->userId = $userId;
        $this->userKey = $userKey;
        $this->ch = curl_init($vidlyUrl);
        curl_setopt_array($this->ch, array(
            CURLOPT_RETURNTRANSFER => 1,
            CURLOPT_POST => 1,
        ));
    }

    protected function sendRequest($action, $xmlPayload)
    {
        $xmlPayload = '<?xml version="1.0"?>
            <Query>
                <Action>'.$action.'</Action>
                <UserID>'.$this->userId.'</UserID>
                <UserKey>'.$this->userKey.'</UserKey>
                '.$xmlPayload.'
            </Query>
        ';

        curl_setopt($this->ch, CURLOPT_POSTFIELDS, array('xml' => $xmlPayload));
        if (($response = curl_exec($this->ch)) === false) {
            $error = curl_error($this->ch);
            throw new Exception($error);
        }
        return simplexml_load_string($response);
    }

    /**
     * @param string $shortUrl
     * @param array $securityParams
     */
    public function getSecurityToken($shortUrl, $securityParams)
    {
        $xmlPayload = "<MediaShortLink>{$shortUrl}</MediaShortLink>";
        foreach ($securityParams as $param => $value) {
            switch ($param) {
                case 'AllowedFromDate':
                    $xmlPayload .= "<AllowedFromDate>{$value}</AllowedFromDate>";
                    break;
                case 'AllowedToDate':
                    $xmlPayload .= "<AllowedToDate>{$value}</AllowedToDate>";
                    break;
                case 'ExpirationTimeSeconds':
                    $xmlPayload .= "<ExpirationTimeSeconds>{$value}</ExpirationTimeSeconds>";
                    break;
                case 'AllowedIP':
                    $xmlPayload .= "<AllowedIP>{$value}</AllowedIP>";
                    break;
            }
        }
        $response = $this->sendRequest('GetSecurityToken', $xmlPayload);
        return (string) $response->Success->Token;
    }


    public function createEmbedCode($host, $cdn, $url, $token)
    {
        return <<<EOT
<iframe frameborder="0" allowfullscreen webkitallowfullscreen mozallowfullscreen  msallowfullscreen width="640" height="360" name="vidly-frame"
    src="http://$cdn/embeded.html?link=$url&new=1&autoplay=false&token=$token">
<a target='_blank' href='http://$host/$url?token=$token'><img src='http://$host/$url/poster?token=$token' /></a>
</iframe>
EOT;
    }

}

$url = '4q2s9c';
$vidly_host = 'vid.ly';
$vidly_cdn = 's.vid.ly';

$api = new VidlyAPI("http://m.{$vidly_host}/api/", VIDLY_USER_ID, VIDLY_USER_KEY);
$token = $api->getSecurityToken($url, array('ExpirationTimeSeconds' => 5));
echo $api->createEmbedCode($vidly_host, $vidly_cdn, $url, $token);

?>